/*
 Sia GAB l’insieme dei grafi orientati con nodi etichettai su generico tipo A ed archi etichettati 
 su generico tipo B, con le seguenti operazioni:
	addN ln: aggiunge i nodi della lista ln non gi\`a contenuti nel grafo
	addE le: aggiunge gli archi della lista le non gi\`a contenuti in g. Pu\`o solevare eccezioni.
	removeN n: rimuove il nodo n e tutti gli archi entranti ed uscenti da n. Pu\`o sol. eccez.
	removeE e: rimuove l'arco e. Pu\'o sollevare eccezioni.
     isNin n: calcola vero sse n \`e un nodo del grafo
	isEin e : calcola vero sse e \`e un arco del grafo
	nodes: calcola la lista di tutti i nodi del grafo
	outN n: calcola la lista dei nodi uscenti da n. Pu\`o sollevare eccez.
 In aggiunta, ad un appropriato costruttore per grafi vuoti ma di fissato tipo A e B, e gli usuali
 additionals.

 Si assuma già definita una classe Java, API, ed un ADT Graph, per un Tipo Astratto di valori modi-
 ficabili GAB con le operazioni descritte sopra.
 Tutte le classi sono parte di un package, GraphPack, contenente anche classi per nodi, Node, e per
 archi, Edge. Inoltre si usino Vector di tipo appropriato per le liste di valori.
 
 (a)	Si mostri una definizione appropriata per API.
 (b)	Si definisca una sottoclasse GraphK per grafi aventi nodi con outdegree massimo fissato al mo-
     mento della costruzione.
*/
 
/* Fuori testo:
 Prologo: Creare 4 file:
 1 per la API API<A>
 1 per la classe Queue<A>
 1 per le eccezioni, newExc
 1 per i codici di tests.
 (a) Fornire API
 (b) Fornire Stato Concreto, AF e C
 (c-d-e-f) Sviluppo:
 (c) Fornire successiva operazione nell'ordine e
 ad ogni definizione procedere con (d),(e),(f)
 (d) Completare la segnatura con le eccezioni sollevate
 (e) Aggiungere definizione classi di eccezioni relative
 (f) compilare ed eseguire test di uso
 */

package GraphPack;

import java.io.*;
import java.util.*;

//Graph<A,B> con upper bound su outdegree, fissato alla creazione
public class Graphk<A,B> extends Graph<A,B> {
    private Vector<Pair<Node<A>,Integer>> outd;
    private int bound;
    private Vector<Edge<A,B>> egs;
    /*
     AF(c) = AF(super)
     I(c) = (c.outd.size()==this.nodes().size()) &&
            (forall i,j\[1..c.outd.size()]:
                 1) this.nodes().contains(c.outd.get(i-1).fst)
                 2) c.outd.get(i-1).fst.equals(c.outd.get(j-1).fst) iff (i == j)
                 3) c.outd.get(i-1).snd <= c.bound
                 4) \#outE(c.outd.get(i-1).fst) == c.outd.get(i-1).snd) &&
            (AF(c)=<nl,el> => 1) \#el==c.egs.size()
                              2) forall i\in[1..c.egs.size()]: c.egs.get(i-1)\in el.
        dove:
            \# e \in siano operatore di cardinalit\`a e appartenenza a insieme;
            outE(n) = {E(n,t,b)\in el | AF(c)=<nl,el>}, sia l'insieme degli archi di AF(c)
                      uscenti dal nodo n (vedi calse Edge per la presentazione degli archi)
     */
    public Graphk(A a, B b, int k){
        super(a,b);
        outd = new Vector<Pair<Node<A>,Integer>>();
        egs = new Vector<Edge<A,B>>();/* sic */
        bound = k;
    }
    public void addN(Vector<Node<A>> ln){
        for(Node<A> n: ln){
            if (!isNin(n)) outd.add(new Pair<Node<A>,Integer>(n,0));
        }
        super.addN(ln);
    }
    public void addE(Vector<Edge<A,B>> le) throws IllegalArgumentException{
        for(Edge<A,B> e: le){
            Node<A> esource = e.getSource();
            Node<A> etarget = e.getTarget();
            if(!(isNin(esource) && isNin(etarget)))
                          throw new IllegalArgumentException("addE: Unexpected Edge nodes");
            if(egs.contains(e)) continue;/* sic */
            if(outdInc(esource)) egs.add(e); /* sic */
        }
        super.addE(le);
    }
    public void removeN(Node<A> n) throws IllegalArgumentException{
        ...
    }
    public void removeE(Edge<A,B> e){
        ...
    }
    private boolean outdInc(Node<A> n) throws IllegalArgumentException{
        ...
    }
    private void outdDec(Node<A> n) {
        ...
    }
}
