/*
 Sia GAB l’insieme dei grafi orientati con nodi etichettai su generico tipo A ed archi etichettati 
 su generico tipo B, con le seguenti operazioni:
	addN ln: aggiunge i nodi della lista ln non gi\`a contenuti nel grafo
	addE le: aggiunge gli archi della lista le non gi\`a contenuti in g. Pu\`o solevare eccezioni.
	removeN n: rimuove il nodo n e tutti gli archi entranti ed uscenti da n. Pu\`o sol. eccez.
	removeE e: rimuove l'arco e. Pu\'o sollevare eccezioni.
     isNin n: calcola vero sse n \`e un nodo del grafo
	isEin e : calcola vero sse e \`e un arco del grafo
	nodes: calcola la lista di tutti i nodi del grafo
	outN n: calcola la lista dei nodi uscenti da n. Pu\`o sollevare eccez.
 In aggiunta, ad un appropriato costruttore per grafi vuoti ma di fissato tipo A e B, e gli usuali
 additionals.

 Si assuma già definita una classe Java, API, ed un ADT Graph, per un Tipo Astratto di valori modi-
 ficabili GAB con le operazioni descritte sopra.
 Tutte le classi sono parte di un package, GraphPack, contenente anche classi per nodi, Node, e per
 archi, Edge. Inoltre si usino Vector di tipo appropriato per le liste di valori.
 
 (a)	Si mostri una definizione approprata per API.
 (b)	Si definisca una sottoclasse GraphK per grafi aventi nodi con outdegree massimo fissato al mo-
     mento della costruzione.
 */

/* Fuori testo:
 Prologo: Creare 4 file:
 1 per la API API<A>
 1 per la classe Queue<A>
 1 per le eccezioni, newExc
 1 per i codici di tests.
 (a) Fornire API
 (b) Fornire Stato Concreto, AF e C
 (c-d-e-f) Sviluppo:
 (c) Fornire successiva operazione nell'ordine e
 ad ogni definizione procedere con (d),(e),(f)
 (d) Completare la segnatura con le eccezioni sollevate
 (e) Aggiungere definizione classi di eccezioni relative
 (f) compilare ed eseguire test di uso
 */

package GraphPack;

import java.util.*;

class Nodetest{
    public static void main(String[] args){
        Node<Integer> n = new Node<Integer>(3);
        System.out.println("nodo n = "+ n.toString() +"   oppure = " + n.toStringHash());
        System.out.println("n.equals(n) = "+ n.equals(n));
        System.out.println("new Node<Integer>(3).equals(new Node<Integer>(3)) = " +new Node<Integer>(3).equals(new Node<Integer>(3)));
    }
}

class Edgetest{
    public static void main(String[] args){
        Node<String> n1 = new Node<String>("a");
        Node<String> n2 = new Node<String>("b");
        Edge<String,Integer> e1 = new Edge<String,Integer>(n1,n2,5);
        System.out.println("arco e1 = "+ e1.toString() +"   oppure = " + e1.toStringHash());
    }
}

class Graphtest1{//clessidra 5 nodi, 4 archi
    public static void main(String[] args){
        Node<String> n1 = new Node<String>("upL");
        Node<String> n2 = new Node<String>("upR");
        Node<String> n3 = new Node<String>("mid");
        Node<String> n4 = new Node<String>("dnL");
        Node<String> n5 = new Node<String>("dnR");
        Vector<Node<String>> nodes = new Vector<Node<String>>();
        nodes.add(n1); nodes.add(n2); nodes.add(n3); nodes.add(n4); nodes.add(n5);
        System.out.println("Vector nodes = "+ nodes);
        Edge<String,Integer> e1 = new Edge<String,Integer>(n1,n3,5);
        Edge<String,Integer> e2 = new Edge<String,Integer>(n2,n3,5);
        Edge<String,Integer> e3 = new Edge<String,Integer>(n3,n4,10);
        Edge<String,Integer> e4 = new Edge<String,Integer>(n3,n5,10);
        Vector<Edge<String,Integer>> edges = new Vector<Edge<String,Integer>>();
        edges.add(e1); edges.add(e2); edges.add(e3); edges.add(e4);
        System.out.println("Vector edges = "+ edges);
        System.out.println("e3 is the same as e4? -- "+ e3.equals(e4));
        Graph<String,Integer> G = new Graph<String,Integer>("Clessidra 5 nodi archi ",4);
        G.addN(nodes); G.addE(edges);
        System.out.println("nodes of G: " + G.nodes());
        System.out.println("graph G = "+ G);
    }
}

class Graphtest2{
    //clessidra 5 nodi, 8 archi (multi d-grafo))
    //addN e addE: riconoscimento di archi equivalenti
    public static void main(String[] args){
        Node<String> n1 = new Node<String>("upL");
        Node<String> n2 = new Node<String>("upR");
        Node<String> n3 = new Node<String>("mid");
        Node<String> n4 = new Node<String>("dnL");
        Node<String> n5 = new Node<String>("dnR");
        Vector<Node<String>> nodes = new Vector<Node<String>>();
        nodes.add(n1); nodes.add(n2); nodes.add(n3); nodes.add(n4); nodes.add(n5);
        System.out.println("Vector nodes = "+ nodes);
        Edge<String,Integer> e1 = new Edge<String,Integer>(n1,n3,5);
        Edge<String,Integer> e2 = new Edge<String,Integer>(n2,n3,5);
        Edge<String,Integer> e3 = new Edge<String,Integer>(n3,n4,10);
        Edge<String,Integer> e4 = new Edge<String,Integer>(n3,n5,10);
        Edge<String,Integer> e5 = new Edge<String,Integer>(n1,n3,3);
        Edge<String,Integer> e6 = new Edge<String,Integer>(n2,n3,8);
        Edge<String,Integer> e7 = new Edge<String,Integer>(n3,n4,7);
        Edge<String,Integer> e8 = new Edge<String,Integer>(n3,n5,4);
        Edge<String,Integer> e9 = new Edge<String,Integer>(n3,n5,4);
        Vector<Edge<String,Integer>> edges = new Vector<Edge<String,Integer>>();
        edges.add(e1); edges.add(e2); edges.add(e3); edges.add(e4); edges.add(e4);
        edges.add(e5); edges.add(e6); edges.add(e7); edges.add(e8); edges.add(e9);
        System.out.println("Vector edges = "+ edges);
        System.out.println("e3 is the same as e4? -- "+ e3.equals(e4));
        Graph<String,Integer> G = new Graph<String,Integer>("Clessidra 5 nodi archi ",8);
        G.addN(nodes); G.addE(edges);
        System.out.println("nodes of G: " + G.nodes());
        System.out.println("graph G = "+ G);
    }
}

class Graphtest3{
    //clessidra 5 nodi, 8 archi (multi d-grafo))
    //removeE: riconoscimento di archi fasulli e sollevamento eccezione
    public static void main(String[] args){
        Node<String> n1 = new Node<String>("upL");
        Node<String> n2 = new Node<String>("upR");
        Node<String> n3 = new Node<String>("mid");
        Node<String> n4 = new Node<String>("dnL");
        Node<String> n5 = new Node<String>("dnR");
        Vector<Node<String>> nodes = new Vector<Node<String>>();
        nodes.add(n1); nodes.add(n2); nodes.add(n3); nodes.add(n4); nodes.add(n5);
        Edge<String,Integer> e1 = new Edge<String,Integer>(n1,n3,5);
        Edge<String,Integer> e2 = new Edge<String,Integer>(n2,n3,5);
        Edge<String,Integer> e3 = new Edge<String,Integer>(n3,n4,10);
        Edge<String,Integer> e4 = new Edge<String,Integer>(n3,n5,10);
        Edge<String,Integer> e5 = new Edge<String,Integer>(n1,n3,3);
        Edge<String,Integer> e6 = new Edge<String,Integer>(n2,n3,8);
        Edge<String,Integer> e7 = new Edge<String,Integer>(n3,n4,7);
        Edge<String,Integer> e8 = new Edge<String,Integer>(n3,n5,4);
        Edge<String,Integer> e9 = new Edge<String,Integer>(n3,n5,4);
        Vector<Edge<String,Integer>> edges = new Vector<Edge<String,Integer>>();
        edges.add(e1); edges.add(e2); edges.add(e3); edges.add(e4); edges.add(e4);
        edges.add(e5); edges.add(e6); edges.add(e7); edges.add(e8); edges.add(e9);
        Graph<String,Integer> G = new Graph<String,Integer>("Clessidra 5 nodi archi ",8);
        G.addN(nodes); G.addE(edges);
        System.out.println("graph G = "+ G);
        Edge<String,Integer> e10;
        e10 = new Edge<String,Integer>(new Node<String>("upL"),new Node<String>("mid"),4);
        G.removeE(e10);
        System.out.println("rimozione arco fake e10 = "+ e10 + "otteniamo\n" + G);
        G.removeE(e7);
    }
}

class Graphtest4{
    //clessidra 5 nodi, 8 archi (multi d-grafo))
    //removeE: rimozione di archi
    public static void main(String[] args){
        Node<String> n1 = new Node<String>("upL");
        Node<String> n2 = new Node<String>("upR");
        Node<String> n3 = new Node<String>("mid");
        Node<String> n4 = new Node<String>("dnL");
        Node<String> n5 = new Node<String>("dnR");
        Vector<Node<String>> nodes = new Vector<Node<String>>();
        nodes.add(n1); nodes.add(n2); nodes.add(n3); nodes.add(n4); nodes.add(n5);
        Edge<String,Integer> e1 = new Edge<String,Integer>(n1,n3,5);
        Edge<String,Integer> e2 = new Edge<String,Integer>(n2,n3,5);
        Edge<String,Integer> e3 = new Edge<String,Integer>(n3,n4,10);
        Edge<String,Integer> e4 = new Edge<String,Integer>(n3,n5,10);
        Edge<String,Integer> e5 = new Edge<String,Integer>(n1,n3,3);
        Edge<String,Integer> e6 = new Edge<String,Integer>(n2,n3,8);
        Edge<String,Integer> e7 = new Edge<String,Integer>(n3,n4,7);
        Edge<String,Integer> e8 = new Edge<String,Integer>(n3,n5,4);
        Edge<String,Integer> e9 = new Edge<String,Integer>(n3,n5,4);
        Vector<Edge<String,Integer>> edges = new Vector<Edge<String,Integer>>();
        edges.add(e1); edges.add(e2); edges.add(e3); edges.add(e4); edges.add(e4);
        edges.add(e5); edges.add(e6); edges.add(e7); edges.add(e8); edges.add(e9);
        Graph<String,Integer> G = new Graph<String,Integer>("Clessidra 5 nodi archi ",8);
        G.addN(nodes); G.addE(edges);
        System.out.println("graph G = "+ G);
        System.out.println("rimozione arco e7 = "+ e7);
        G.removeE(e7);
        System.out.println("otteniamo\n" + G);
    }
}

class Graphtest5{
    //clessidra 5 nodi, 8 archi (multi d-grafo))
    //removeN: rimozione nodo fasullo
    public static void main(String[] args){
        Node<String> n1 = new Node<String>("upL");
        Node<String> n2 = new Node<String>("upR");
        Node<String> n3 = new Node<String>("mid");
        Node<String> n4 = new Node<String>("dnL");
        Node<String> n5 = new Node<String>("dnR");
        Vector<Node<String>> nodes = new Vector<Node<String>>();
        nodes.add(n1); nodes.add(n2); nodes.add(n3); nodes.add(n4); nodes.add(n5);
        Edge<String,Integer> e1 = new Edge<String,Integer>(n1,n3,5);
        Edge<String,Integer> e2 = new Edge<String,Integer>(n2,n3,5);
        Edge<String,Integer> e3 = new Edge<String,Integer>(n3,n4,10);
        Edge<String,Integer> e4 = new Edge<String,Integer>(n3,n5,10);
        Edge<String,Integer> e5 = new Edge<String,Integer>(n1,n3,3);
        Edge<String,Integer> e6 = new Edge<String,Integer>(n2,n3,8);
        Edge<String,Integer> e7 = new Edge<String,Integer>(n3,n4,7);
        Edge<String,Integer> e8 = new Edge<String,Integer>(n3,n5,4);
        Edge<String,Integer> e9 = new Edge<String,Integer>(n3,n5,4);
        Vector<Edge<String,Integer>> edges = new Vector<Edge<String,Integer>>();
        edges.add(e1); edges.add(e2); edges.add(e3); edges.add(e4); edges.add(e4);
        edges.add(e5); edges.add(e6); edges.add(e7); edges.add(e8); edges.add(e9);
        Graph<String,Integer> G = new Graph<String,Integer>("Clessidra 5 nodi archi ",8);
        G.addN(nodes); G.addE(edges);
        System.out.println("graph G = "+ G);
        System.out.println("rimozione nodo fake = "+ new Node<String>("upL"));
        G.removeN(new Node<String>("upL"));
        System.out.println("otteniamo\n" + G);
    }
}

class Graphtest6{
    //clessidra 5 nodi, 8 archi (multi d-grafo))
    //removeN: rimozione nodi
    public static void main(String[] args){
        Node<String> n1 = new Node<String>("upL");
        Node<String> n2 = new Node<String>("upR");
        Node<String> n3 = new Node<String>("mid");
        Node<String> n4 = new Node<String>("dnL");
        Node<String> n5 = new Node<String>("dnR");
        Vector<Node<String>> nodes = new Vector<Node<String>>();
        nodes.add(n1); nodes.add(n2); nodes.add(n3); nodes.add(n4); nodes.add(n5);
        Edge<String,Integer> e1 = new Edge<String,Integer>(n1,n3,5);
        Edge<String,Integer> e2 = new Edge<String,Integer>(n2,n3,5);
        Edge<String,Integer> e3 = new Edge<String,Integer>(n3,n4,10);
        Edge<String,Integer> e4 = new Edge<String,Integer>(n3,n5,10);
        Edge<String,Integer> e5 = new Edge<String,Integer>(n1,n3,3);
        Edge<String,Integer> e6 = new Edge<String,Integer>(n2,n3,8);
        Edge<String,Integer> e7 = new Edge<String,Integer>(n3,n4,7);
        Edge<String,Integer> e8 = new Edge<String,Integer>(n3,n5,4);
        Edge<String,Integer> e9 = new Edge<String,Integer>(n3,n5,4);
        Vector<Edge<String,Integer>> edges = new Vector<Edge<String,Integer>>();
        edges.add(e1); edges.add(e2); edges.add(e3); edges.add(e4); edges.add(e4);
        edges.add(e5); edges.add(e6); edges.add(e7); edges.add(e8); edges.add(e9);
        Graph<String,Integer> G = new Graph<String,Integer>("Clessidra 5 nodi archi ",8);
        G.addN(nodes); G.addE(edges);
        System.out.println("graph G = "+ G);
        System.out.println("rimozione nodo n1 = "+ n1);
        G.removeN(n1);
        System.out.println("otteniamo\n" + G);
        System.out.println("rimozione nodo n3 = "+ n3);
        G.removeN(n3);
        System.out.println("otteniamo\n" + G);
    }
}

class Graphtest7{
    //clessidra 5 nodi, 8 archi (multi d-grafo)) e sue modifiche
    //clone: aggiunta e rimozione da G non coinvolge il suo clone
    public static void main(String[] args) throws CloneNotSupportedException{
        Node<String> n1 = new Node<String>("upL");
        Node<String> n2 = new Node<String>("upR");
        Node<String> n3 = new Node<String>("mid");
        Node<String> n4 = new Node<String>("dnL");
        Node<String> n5 = new Node<String>("dnR");
        Vector<Node<String>> nodes = new Vector<Node<String>>();
        nodes.add(n1); nodes.add(n2); nodes.add(n3); nodes.add(n4); nodes.add(n5);
        Edge<String,Integer> e1 = new Edge<String,Integer>(n1,n3,5);
        Edge<String,Integer> e2 = new Edge<String,Integer>(n2,n3,5);
        Edge<String,Integer> e3 = new Edge<String,Integer>(n3,n4,10);
        Edge<String,Integer> e4 = new Edge<String,Integer>(n3,n5,10);
        Edge<String,Integer> e5 = new Edge<String,Integer>(n1,n3,3);
        Edge<String,Integer> e6 = new Edge<String,Integer>(n2,n3,8);
        Edge<String,Integer> e7 = new Edge<String,Integer>(n3,n4,7);
        Edge<String,Integer> e8 = new Edge<String,Integer>(n3,n5,4);
        Edge<String,Integer> e9 = new Edge<String,Integer>(n3,n5,4);
        Vector<Edge<String,Integer>> edges = new Vector<Edge<String,Integer>>();
        edges.add(e1); edges.add(e2); edges.add(e3); edges.add(e4); edges.add(e4);
        edges.add(e5); edges.add(e6); edges.add(e7); edges.add(e8); edges.add(e9);
        Graph<String,Integer> G = new Graph<String,Integer>("Clessidra 5 nodi archi ",8);
        G.addN(nodes); G.addE(edges);
        System.out.println("graph G = \n"+ G);
        Graph<String,Integer> Gclone = G.clone();
        System.out.println("graph Gclone = G.clone():  \n"+ Gclone);
        System.out.println("rimozione nodo n1 = "+ n1 + ", da G");
        G.removeN(n1);
        System.out.println("G diventa\n" + G);
        System.out.println("rimozione arco e3 = "+ e3 + ", da G");
        G.removeE(e3);
        System.out.println("G diventa\n" + G);
        Edge<String,Integer> e10 = new Edge<String,Integer>(n2,n5,13);
        Edge<String,Integer> e11 = new Edge<String,Integer>(n2,n4,17);
        System.out.println("aggiunta archi e10 = "+ e10 + " ed e11 = "+ e11 + ", a G");
        edges.clear(); edges.add(e10); edges.add(e11);
        G.addE(edges);
        System.out.println("G diventa\n" + G);
        System.out.println("rimozione nodo n3 = "+ n3 + ", da G");
        G.removeN(n3);
        System.out.println("G diventa\n" + G);
        System.out.println("graph G = \n"+ G);
        System.out.println("graph Gclone =\n" + Gclone);
    }
}


